/*
    Copyright (C) 1999 by  XCIN TEAM

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/      

#ifdef HAVE_CONFIG_H
#  include "config.h"
#endif

#include <string.h>
#include <iconv.h>
#include <langinfo.h>
#include "module.h"

typedef struct {
    short n;
    ubyte_t begin[N_CCODE_RULE], end[N_CCODE_RULE];
    short num[N_CCODE_RULE], ac_num[N_CCODE_RULE];
    short total_num;
    unsigned long base;
} ccode_t;

static ccode_t charcode[UCH_SIZE];

static unsigned int total_char;
static byte_t highest_idx;


void
ccode_init(charcode_t *ccp, int n)
{
    int i, j, idx;

    for (i=0; i<UCH_SIZE && i<n && ccp[i].n; i++) {
	idx = charcode[i].n = ccp[i].n;
	for (j=0; j<idx; j++) {
	    charcode[i].begin[j] = ccp[i].begin[j];
	    charcode[i].end[j] = ccp[i].end[j];
	    charcode[i].num[j] = charcode[i].end[j] - charcode[i].begin[j] + 1;
	    charcode[i].total_num += charcode[i].num[j];
	    if (j > 0)
		charcode[i].ac_num[j] = 
			charcode[i].ac_num[j-1] + charcode[i].num[j-1];
	}
	if (i == 0)
	    charcode[i].base = 1;
	else
	    charcode[i].base = charcode[i-1].total_num * charcode[i-1].base;
    }
    total_char = charcode[i-1].total_num * charcode[i-1].base;
    highest_idx = i - 1;
}

void
ccode_info(ccode_info_t *info)
{
    int i, j;

    info->total_char = total_char;
    info->n_ch_encoding = highest_idx + 1;

    for (i=0; i<=highest_idx; i++) {
	bzero(info->ccode+i, sizeof(charcode_t));
	info->ccode[i].n = charcode[i].n;
	for (j=0; j<charcode[i].n; j++) {
	    info->ccode[i].begin[j] = charcode[i].begin[j];
	    info->ccode[i].end[j] = charcode[i].end[j];
	}
    }
}

unsigned int
ccode_to_ucs4(char *utf8)
{
    char *p = utf8;
    unsigned int ucs4 = 0;
    unsigned int len = strlen(utf8);
    int nbytes;
    int nchars = 0;

    while (len && (nbytes = utf8_to_ucs4(p, &ucs4, len)) > 0)
    {
	nchars ++;
	p += nbytes;
	len -= nbytes;
    }
    
    return (nchars == 1) ? ucs4 : 0;
}

int
ccode_to_char(unsigned int ucs4, char *mbs)
{
    return (!ucs4_to_utf8(ucs4, mbs)) ? 0 : 1;
}
